import { openBlock, createElementBlock, createCommentVNode, createElementVNode, normalizeClass, createVNode, renderSlot, ref, watch, computed, unref, withCtx, toDisplayString, Fragment, renderList, createBlock, isRef, inject, createTextVNode, withModifiers, Transition, mergeProps, toHandlers } from 'vue';
import { Combobox, ComboboxButton, ComboboxInput, TransitionRoot, ComboboxOptions, ComboboxOption, Dialog, TransitionChild, DialogPanel, Listbox, ListboxButton, ListboxOptions, ListboxOption } from '@headlessui/vue';
import { ChevronDownIcon, CheckIcon } from '@heroicons/vue/solid';
import dayjs from 'dayjs';
import { useField, useForm } from 'vee-validate';
import Datepicker from '@vuepic/vue-datepicker';
import vueFilePond from 'vue-filepond';
import 'filepond/dist/filepond.min.css';
import 'filepond-plugin-image-preview/dist/filepond-plugin-image-preview.min.css';
import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type';
import FilePondPluginImagePreview from 'filepond-plugin-image-preview';
import FilePondPlugFileValidateSize from 'filepond-plugin-file-validate-size';

const _hoisted_1$7 = {
  key: 0,
  class: "animate-spin -ml-1 mr-3 h-5 w-5 text-white",
  xmlns: "http://www.w3.org/2000/svg",
  fill: "none",
  viewBox: "0 0 24 24"
};
const _hoisted_2$4 = /*#__PURE__*/createElementVNode("circle", {
  class: "opacity-25",
  cx: "12",
  cy: "12",
  r: "10",
  stroke: "currentColor",
  "stroke-width": "4"
}, null, -1 /* HOISTED */);
const _hoisted_3$4 = /*#__PURE__*/createElementVNode("path", {
  class: "opacity-75",
  fill: "currentColor",
  d: "M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"
}, null, -1 /* HOISTED */);
const _hoisted_4$2 = [
  _hoisted_2$4,
  _hoisted_3$4
];


  
  
var script$9 = {
  __name: 'VLoading',
  props: {
    show: {
      type: Boolean,
      default: false,
    },
  },
  setup(__props) {

  
  
return (_ctx, _cache) => {
  return (__props.show)
    ? (openBlock(), createElementBlock("svg", _hoisted_1$7, _hoisted_4$2))
    : createCommentVNode("v-if", true)
}
}

};

script$9.__file = "src/components/VLoading.vue";

const _hoisted_1$6 = ["disabled"];


  const __default__$6 = {
    name: 'VButton',
  };

var script$8 = /*#__PURE__*/Object.assign(__default__$6, {
  props: {
  loading: {
    default: false,
  },
  disabled: {
    default: false,
  },
  width: {
    default: "auto",
  },
  height: {
    default: "auto",
  },
},
  setup(__props) {

const props = __props;



return (_ctx, _cache) => {
  return (openBlock(), createElementBlock("button", {
    class: normalizeClass(`inline-flex 
      items-center 
      px-3 
      py-2 
      border 
      border-transparent 
      text-sm 
      leading-4 
      font-medium 
      rounded-md 
      shadow-sm 
      text-untitled-gray-800 
      ${
        props.disabled
          ? 'bg-untitled-gray-600  text-untitled-gray-500'
          : 'bg-untitled-gray-200'
      } 
      hover:bg-untitled-gray-600 
      focus:outline-none focus:ring-2 
      focus:ring-offset-2 
      focus:ring-untitled-gray-500 
      text-center 
      h-[${props.height}] 
      w-[${props.width}]`),
    disabled: props.loading || props.disabled
  }, [
    createVNode(script$9, {
      show: props.loading
    }, null, 8 /* PROPS */, ["show"]),
    renderSlot(_ctx.$slots, "default")
  ], 10 /* CLASS, PROPS */, _hoisted_1$6))
}
}

});

script$8.__file = "src/components/VButton.vue";

const _hoisted_1$5 = { class: "z-[99999999999] text-untitled-gray-400" };
const _hoisted_2$3 = { class: "z-[10] h-10 relative w-full cursor-default overflow-hidden rounded-lg bg-white text-left border border-untitled-gray-300 focus:outline-none focus-visible:ring-2 focus-visible:ring-white focus-visible:ring-opacity-75 focus-visible:ring-offset-2 focus-visible:ring-offset-teal-300 sm:text-sm" };
const _hoisted_3$3 = {
  key: 0,
  class: "flex items-center ml-5 max-h-[50px] h-[50px] text-xs w-full hover:cursor-text"
};
const _hoisted_4$1 = ["for"];
const _hoisted_5$1 = { class: "relative" };
const _hoisted_6$1 = {
  key: 0,
  class: "relative cursor-default select-none py-2 px-4 text-gray-700"
};
const _hoisted_7$1 = {
  key: 1,
  class: "relative cursor-default select-none py-2 px-4 text-gray-700"
};
const _hoisted_8$1 = { key: 4 };
const _hoisted_9$1 = { class: "mt-2 text-red-500 text-xs italic" };


const __default__$5 = {
  name: "VCombobox",
};

var script$7 = /*#__PURE__*/Object.assign(__default__$5, {
  props: {
  modelValue: {
    default: null,
  },
  options: {
    default: [],
  },
  isMultiple: {
    default: false,
    type: Boolean,
  },
  isLoading: {
    default: false,
    type: Boolean,
  },
  isDisabled: {
    default: false,
    type: Boolean,
  },
  optionName: {
    default: "name",
    type: String,
  },
  placeholder: {
    default: "Placeholder",
    type: String,
  },
  name: {
    default: "name",
    type: String,
  },
  rules: {
    default: [],
  },
},
  emits: ["update:modelValue"],
  setup(__props, { emit }) {

const props = __props;





const query = ref("");

const totalSelected = ref();
const showSelectedItem = ref(true);
const comboBoxID = dayjs(new Date()).format("HmSSS");

const changeTextQuery = (event) => {
  query.value = event.target.value;
};

const handleSearch = (e) => {
  showSelectedItem.value = e?.target?.value?.length ? false : true;
};

const comboboxValue = ref(props.modelValue);

watch(comboboxValue, (watchValue) => {
  value.value = watchValue;
});
const displaySelectedItem = () => {
  const totalSeletedItem = value?.value?.length + 1;

  totalSelected.value = totalSeletedItem;

  if (value?.value?.length <= 3) {
    return value?.value
      ?.map((item) => {
        return item[props.optionName];
      })
      .join(",");
  } else {
    return (
      value?.value
        ?.map((item) => item[props.optionName])
        .slice(0, 3)
        .join(" , ") + ` +${totalSeletedItem - 4}`
    );
  }
};

const filteredItems = computed(() =>
  query.value === ""
    ? props?.options
    : props?.options?.filter((item) =>
        item[props.optionName]
          .toLowerCase()
          .replace(/\s+/g, "")
          .includes(query.value.toLowerCase().replace(/\s+/g, ""))
      )
);

const validateField = (value) => {
  let error = true;

  for (let i = 0; i < props.rules?.length; i++) {
    const rule = props.rules[i];

    error = rule(value);

    if (error != true) {
      break;
    }
  }

  emit("update:modelValue", value);

  return error;
};

const { errorMessage, value } = useField(props.name, validateField, {
  validateOnValueUpdate: true,
  initialValue: props?.modelValue,
});

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock("div", null, [
    createVNode(unref(Combobox), {
      modelValue: comboboxValue.value,
      "onUpdate:modelValue": _cache[6] || (_cache[6] = $event => ((comboboxValue).value = $event)),
      multiple: __props.isMultiple,
      disabled: __props.isDisabled,
      name: __props.name
    }, {
      default: withCtx(() => [
        createElementVNode("div", _hoisted_1$5, [
          createElementVNode("div", _hoisted_2$3, [
            (__props.isMultiple && showSelectedItem.value && query.value.length <= 0)
              ? (openBlock(), createElementBlock("p", _hoisted_3$3, [
                  createElementVNode("label", {
                    for: `combo${unref(comboBoxID)}`,
                    class: "z-10 mr-3 mb-3 w-4/5 hover:cursor-text"
                  }, toDisplayString(displaySelectedItem()), 9 /* TEXT, PROPS */, _hoisted_4$1)
                ]))
              : createCommentVNode("v-if", true),
            createVNode(unref(ComboboxButton), {
              as: "div",
              class: normalizeClass(["absolute inset-y-0 right-0 flex items-center pr-2 w-full hover:cursor-text", { 'bg-[#f6f6f6]': __props.isDisabled }]),
              onClick: _cache[2] || (_cache[2] = $event => (handleSearch()))
            }, {
              default: withCtx(() => [
                createVNode(unref(ComboboxInput), {
                  id: `combo${unref(comboBoxID)}`,
                  class: "w-full ml-5 appearance-none border-none outline-none",
                  displayValue: (item) => (item ? item[props.optionName] : ''),
                  placeholder: unref(value)?.length > 0 ? '' : __props.placeholder,
                  onChange: _cache[0] || (_cache[0] = $event => (changeTextQuery($event))),
                  onKeypress: _cache[1] || (_cache[1] = $event => (handleSearch())),
                  autocomplete: "off",
                  disabled: __props.isDisabled
                }, null, 8 /* PROPS */, ["id", "displayValue", "placeholder", "disabled"]),
                createVNode(unref(ChevronDownIcon), {
                  class: "h-5 w-5 text-gray-400 absolute mr-2 right-0",
                  "aria-hidden": "true"
                })
              ]),
              _: 1 /* STABLE */
            }, 8 /* PROPS */, ["class"])
          ]),
          createVNode(unref(TransitionRoot), {
            leave: "transition ease-in duration-100",
            leaveFrom: "opacity-100",
            leaveTo: "opacity-0",
            onAfterLeave: _cache[5] || (_cache[5] = $event => ((query.value = ''), (showSelectedItem.value = true)))
          }, {
            default: withCtx(() => [
              createElementVNode("div", _hoisted_5$1, [
                createVNode(unref(ComboboxOptions), { class: "w-full z-[10000] absolute mt-1 max-h-60 overflow-auto rounded-md bg-white py-1 text-base shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none sm:text-sm" }, {
                  default: withCtx(() => [
                    (
                  !props.isLoading &&
                  unref(filteredItems)?.length === 0 &&
                  query.value !== ''
                )
                      ? (openBlock(), createElementBlock("div", _hoisted_6$1, " Nothing found. "))
                      : createCommentVNode("v-if", true),
                    (props.isLoading)
                      ? (openBlock(), createElementBlock("div", _hoisted_7$1, " Loading... "))
                      : createCommentVNode("v-if", true),
                    (
                  props.isMultiple &&
                  comboboxValue.value?.length > 0 &&
                  !props.isLoading
                )
                      ? (openBlock(), createElementBlock("p", {
                          key: 2,
                          class: "text-center hover:cursor-pointer",
                          onClick: _cache[3] || (_cache[3] = $event => (comboboxValue.value = []))
                        }, " Deselect "))
                      : createCommentVNode("v-if", true),
                    (
                  props.isMultiple &&
                  comboboxValue.value?.length == 0 &&
                  !props.isLoading
                )
                      ? (openBlock(), createElementBlock("p", {
                          key: 3,
                          class: "text-center hover:cursor-pointer",
                          onClick: _cache[4] || (_cache[4] = $event => (comboboxValue.value = __props.options))
                        }, " Select All "))
                      : createCommentVNode("v-if", true),
                    (!props.isLoading)
                      ? (openBlock(), createElementBlock("span", _hoisted_8$1, [
                          (openBlock(true), createElementBlock(Fragment, null, renderList(unref(filteredItems), (item) => {
                            return (openBlock(), createBlock(unref(ComboboxOption), {
                              as: "template",
                              key: item.id,
                              value: item
                            }, {
                              default: withCtx(({ selected, active }) => [
                                createElementVNode("li", {
                                  class: normalizeClass(["relative cursor-default select-none py-2 pl-10 pr-4", {
                      ' bg-untitled-gray-200 text-untitled-gray-800': active,
                      'text-gray-900': !active,
                    }])
                                }, [
                                  createElementVNode("span", {
                                    class: normalizeClass(["block truncate", {
                        'font-medium': selected,
                        'font-normal': !selected,
                      }])
                                  }, toDisplayString(item[props.optionName]), 3 /* TEXT, CLASS */),
                                  selected
                                    ? (openBlock(), createElementBlock("span", {
                                        key: 0,
                                        class: normalizeClass(["absolute inset-y-0 left-0 flex items-center pl-3", {
                        'text-untitled-gray-800': active,
                        'text-untitled-gray-400': !active,
                      }])
                                      }, [
                                        createVNode(unref(CheckIcon), {
                                          class: "h-5 w-5",
                                          "aria-hidden": "true"
                                        })
                                      ], 2 /* CLASS */))
                                    : createCommentVNode("v-if", true)
                                ], 2 /* CLASS */)
                              ]),
                              _: 2 /* DYNAMIC */
                            }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["value"]))
                          }), 128 /* KEYED_FRAGMENT */))
                        ]))
                      : createCommentVNode("v-if", true)
                  ]),
                  _: 1 /* STABLE */
                })
              ])
            ]),
            _: 1 /* STABLE */
          })
        ])
      ]),
      _: 1 /* STABLE */
    }, 8 /* PROPS */, ["modelValue", "multiple", "disabled", "name"]),
    createElementVNode("span", _hoisted_9$1, toDisplayString(unref(errorMessage)), 1 /* TEXT */)
  ]))
}
}

});

script$7.__file = "src/components/VCombobox.vue";

const _hoisted_1$4 = { class: "mt-2 text-red-500 text-xs italic" };


var script$6 = {
  __name: 'VDatePicker',
  props: {
  modelValue: {
    default: ''
  },
  range:{
    default: false,
    type: Boolean
  },
  disabled:{
    default: false,
    type: Boolean
  },
  enableTimePicker:{
    default: false,
    type: Boolean
  },
  minDate:{
    default: null,
  },
  maxDate:{
    default: null,
  },
  name:{
    default: 'date'
  },
  rules:{
    default: []
  }
},
  emits: ["update:modelValue"],
  setup(__props, { emit }) {

const props = __props;








const validateField = (value) => {
let error = true;

for (let i = 0; i < props.rules?.length; i++) {
  const rule = props.rules[i];

  error = rule(value);

  if (error != true) {
    break;
  }
}

emit("update:modelValue", value);

return error;
};

const { errorMessage, value } = useField(
props.name,
validateField,
{
  validateOnValueUpdate: false,
  initialValue: props?.modelValue !== undefined ? props.modelValue : null,
}
);

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock(Fragment, null, [
    createVNode(unref(Datepicker), {
      modelValue: unref(value),
      "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (isRef(value) ? (value).value = $event : null)),
      class: "text-sm",
      range: __props.range,
      disabled: __props.disabled,
      "enable-time-picker": __props.enableTimePicker,
      "min-date": __props.minDate,
      "max-date": __props.maxDate,
      name: __props.name
    }, null, 8 /* PROPS */, ["modelValue", "range", "disabled", "enable-time-picker", "min-date", "max-date", "name"]),
    createElementVNode("span", _hoisted_1$4, toDisplayString(unref(errorMessage)), 1 /* TEXT */)
  ], 64 /* STABLE_FRAGMENT */))
}
}

};

script$6.__file = "src/components/VDatePicker.vue";

const _hoisted_1$3 = /*#__PURE__*/createElementVNode("div", { class: "fixed inset-0 bg-black bg-opacity-25" }, null, -1 /* HOISTED */);
const _hoisted_2$2 = { class: "fixed inset-0 overflow-y-auto" };
const _hoisted_3$2 = { class: "flex min-h-full items-center justify-center p-4 text-center" };


const __default__$4 = {
  name: "VDialog",
};

var script$5 = /*#__PURE__*/Object.assign(__default__$4, {
  props: {
  modelValue: {
    default: false,
  },
},
  emits: ["update:modelValue"],
  setup(__props, { emit }) {

const props = __props;





const value = computed({
  get() {
    return props.modelValue;
  },
  set(value) {
    emit("update:modelValue", value);
  },
});

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock(Fragment, null, [
    createElementVNode("div", null, [
      renderSlot(_ctx.$slots, "activator")
    ]),
    createVNode(unref(TransitionRoot), {
      appear: "",
      show: unref(value),
      as: "template"
    }, {
      default: withCtx(() => [
        createVNode(unref(Dialog), {
          as: "div",
          onClose: _cache[0] || (_cache[0] = $event => (value.value = false)),
          class: "relative z-10"
        }, {
          default: withCtx(() => [
            createVNode(unref(TransitionChild), {
              as: "template",
              enter: "duration-300 ease-out",
              "enter-from": "opacity-0",
              "enter-to": "opacity-100",
              leave: "duration-200 ease-in",
              "leave-from": "opacity-100",
              "leave-to": "opacity-0"
            }, {
              default: withCtx(() => [
                _hoisted_1$3
              ]),
              _: 1 /* STABLE */
            }),
            createElementVNode("div", _hoisted_2$2, [
              createElementVNode("div", _hoisted_3$2, [
                createVNode(unref(TransitionChild), {
                  as: "template",
                  enter: "duration-300 ease-out",
                  "enter-from": "opacity-0 scale-95",
                  "enter-to": "opacity-100 scale-100",
                  leave: "duration-200 ease-in",
                  "leave-from": "opacity-100 scale-100",
                  "leave-to": "opacity-0 scale-95"
                }, {
                  default: withCtx(() => [
                    createVNode(unref(DialogPanel), { class: "w-full max-w-md transform rounded-2xl bg-white p-6 text-left align-middle shadow-xl transition-all" }, {
                      default: withCtx(() => [
                        renderSlot(_ctx.$slots, "default")
                      ]),
                      _: 3 /* FORWARDED */
                    })
                  ]),
                  _: 3 /* FORWARDED */
                })
              ])
            ])
          ]),
          _: 3 /* FORWARDED */
        })
      ]),
      _: 3 /* FORWARDED */
    }, 8 /* PROPS */, ["show"])
  ], 64 /* STABLE_FRAGMENT */))
}
}

});

script$5.__file = "src/components/VDialog.vue";

const __default__$3 = {
  name: "VFileInput",
};

var script$4 = /*#__PURE__*/Object.assign(__default__$3, {
  setup(__props) {

const FilePond = vueFilePond(
  FilePondPluginFileValidateType,
  FilePondPluginImagePreview,
  FilePondPlugFileValidateSize
);

const pond = ref(null);
const file = ref(null);
const axios = inject("axios");

const upload = () => {
  if (file?.value === null) return;

  store(file?.value, {
    visibility: "public-read",
    headers: {},
  }).then((response) => {
    console.log(response);
  });
};

const store = async (file, options = {}) => {
  const response = await axios.post(
    options.signedStorageUrl
      ? options.signedStorageUrl
      : "/vapor/signed-storage-url",
    {
      bucket: options.bucket || "",
      content_type: options.contentType || file.type,
      expires: options.expires || "",
      visibility: options.visibility || "",
      ...options.data,
    },
    {
      baseURL: options.baseURL || null,
      headers: options.headers || {},
      ...options.options,
    }
  );

  let headers = response.data.headers;

  if ("Host" in headers) {
    delete headers.Host;
    delete headers["x-amz-acl"];
  }

  if (typeof options.progress === "undefined") {
    options.progress = () => {};
  }

  const cancelToken = options.cancelToken || "";

  await axios.put(response.data.url, file, {
    cancelToken: cancelToken,
    headers: headers,
    onUploadProgress: (progressEvent) => {
      options.progress(progressEvent.loaded / progressEvent.total);
    },
  });

  response.data.extension = file.name.split(".").pop();

  return response.data;
};

const handleFilePondUpdateFiles = (value) => {
  file.value = value[0]?.file;
};

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock(Fragment, null, [
    createVNode(unref(FilePond), {
      className: "cursor-pointer text-sm",
      "label-idle": "Drop your video file here or click to browse your computer (Accepted File : mp4, mov, mkv)",
      ref_key: "pond",
      ref: pond,
      credits: "false",
      "allow-multiple": "false",
      allowFileTypeValidation: "true",
      allowFileSizeValidation: "true",
      fileValidateTypeDetectType: "true",
      "max-files": "1",
      maxFileSize: "200MB",
      allowRemove: "true",
      allowProcess: "false",
      checkValidity: "false",
      "instant-upload": "false",
      "accepted-file-types": "video/mp4, video/x-matroska, video/quicktime",
      onUpdatefiles: handleFilePondUpdateFiles
    }, null, 512 /* NEED_PATCH */),
    createVNode(script$8, { onClick: upload }, {
      default: withCtx(() => [
        createTextVNode("Upload")
      ]),
      _: 1 /* STABLE */
    })
  ], 64 /* STABLE_FRAGMENT */))
}
}

});

script$4.__file = "src/components/VFileInput.vue";

const __default__$2 = {
  name: "VForm",
};

var script$3 = /*#__PURE__*/Object.assign(__default__$2, {
  emits: ["submit"],
  setup(__props, { emit }) {



const { handleSubmit } = useForm();

const onSubmit = handleSubmit((value) => {
  emit("submit", value);
});

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock("form", {
    onSubmit: _cache[0] || (_cache[0] = withModifiers((...args) => (unref(onSubmit) && unref(onSubmit)(...args)), ["prevent"]))
  }, [
    renderSlot(_ctx.$slots, "default")
  ], 32 /* HYDRATE_EVENTS */))
}
}

});

script$3.__file = "src/components/VForm.vue";

const _hoisted_1$2 = { class: "z-[99999999999] text-untitled-gray-400" };
const _hoisted_2$1 = {
  key: 0,
  class: "block truncate text-untitled-gray-400 font-thin ml-[20px]"
};
const _hoisted_3$1 = {
  key: 1,
  class: "block truncate text-untitled-gray-400 font-thin ml-[20px]"
};
const _hoisted_4 = { class: "pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2" };
const _hoisted_5 = { class: "relative" };
const _hoisted_6 = {
  key: 0,
  class: "relative cursor-default select-none py-2 px-4 text-gray-700"
};
const _hoisted_7 = {
  key: 1,
  class: "relative cursor-default select-none py-2 px-4 text-gray-700"
};
const _hoisted_8 = { key: 4 };
const _hoisted_9 = {
  key: 0,
  class: "absolute inset-y-0 left-0 flex items-center pl-3 text-untitled-gray-400"
};
const _hoisted_10 = { class: "mt-2 text-red-500 text-xs italic" };


const __default__$1 = {
  name: "VSelect",
};

var script$2 = /*#__PURE__*/Object.assign(__default__$1, {
  props: {
  modelValue: {
    default: null,
  },
  options: {
    default: [],
  },
  isMultiple: {
    default: false,
    type: Boolean,
  },
  isLoading: {
    default: false,
    type: Boolean,
  },
  isDisabled: {
    default: false,
    type: Boolean,
  },
  placeholder: {
    default: "Placeholder",
  },
  optionName: {
    default: "name",
  },
  name: {
    default: "name",
    type: String,
  },
  rules: {
    default: [],
  },
},
  emits: ["update:modelValue"],
  setup(__props, { emit }) {

const props = __props;





const selectValue = ref(props.modelValue);

watch(selectValue, (watchValue) => {
  value.value = watchValue;
});

const displaySelected = () => {
  const totalSeletedItem = value?.value?.length + 1;

  if (value?.value?.length <= 3) {
    return value?.value
      ?.map((item) => {
        return item.name;
      })
      .join(",");
  } else {
    return (
      value?.value
        ?.map((item) => item.name)
        .slice(0, 3)
        .join(" , ") + ` +${totalSeletedItem - 4}`
    );
  }
};

const validateField = (value) => {
  let error = true;

  for (let i = 0; i < props.rules?.length; i++) {
    const rule = props.rules[i];

    error = rule(value);

    if (error != true) {
      break;
    }
  }

  emit("update:modelValue", value);

  return error;
};

const { errorMessage, value } = useField(props.name, validateField, {
  validateOnValueUpdate: true,
  initialValue: props?.modelValue,
});

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock("div", null, [
    createVNode(unref(Listbox), {
      modelValue: selectValue.value,
      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => ((selectValue).value = $event)),
      multiple: __props.isMultiple,
      disabled: __props.isDisabled,
      name: __props.name
    }, {
      default: withCtx(() => [
        createElementVNode("div", _hoisted_1$2, [
          createVNode(unref(ListboxButton), {
            class: normalizeClass(["z-[10] w-min-[400px] w-max-[500px] h-10 relative w-full cursor-default overflow-hidden rounded-lg bg-white text-left border border-untitled-gray-300 focus:outline-none focus-visible:ring-2 focus-visible:ring-white focus-visible:ring-opacity-75 focus-visible:ring-offset-2 focus-visible:ring-offset-teal-300 sm:text-sm", { 'bg-[#f6f6f6]': __props.isDisabled }])
          }, {
            default: withCtx(() => [
              (__props.isMultiple)
                ? (openBlock(), createElementBlock("span", _hoisted_2$1, toDisplayString(selectValue.value?.length ? displaySelected() : __props.placeholder), 1 /* TEXT */))
                : (openBlock(), createElementBlock("span", _hoisted_3$1, toDisplayString(selectValue.value ? selectValue.value[__props.optionName] : __props.placeholder), 1 /* TEXT */)),
              createElementVNode("span", _hoisted_4, [
                createVNode(unref(ChevronDownIcon), {
                  class: "h-5 w-5 text-gray-400 absolute mr-2 right-0",
                  "aria-hidden": "true"
                })
              ])
            ]),
            _: 1 /* STABLE */
          }, 8 /* PROPS */, ["class"]),
          createVNode(Transition, {
            "leave-active-class": "transition duration-100 ease-in",
            "leave-from-class": "opacity-100",
            "leave-to-class": "opacity-0"
          }, {
            default: withCtx(() => [
              createElementVNode("div", _hoisted_5, [
                createVNode(unref(ListboxOptions), { class: "z-[10000] absolute mt-1 max-h-60 w-full overflow-auto rounded-md bg-white py-1 text-base shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none sm:text-sm" }, {
                  default: withCtx(() => [
                    (!props.isLoading && __props.options?.length === 0 && _ctx.query !== '')
                      ? (openBlock(), createElementBlock("div", _hoisted_6, " Nothing found. "))
                      : createCommentVNode("v-if", true),
                    (props.isLoading)
                      ? (openBlock(), createElementBlock("div", _hoisted_7, " Loading... "))
                      : createCommentVNode("v-if", true),
                    (__props.isMultiple && selectValue.value?.length > 0 && !props.isLoading)
                      ? (openBlock(), createElementBlock("p", {
                          key: 2,
                          class: "text-center hover:cursor-pointer",
                          onClick: _cache[0] || (_cache[0] = $event => (selectValue.value = []))
                        }, " Deselect "))
                      : createCommentVNode("v-if", true),
                    (
                  __props.isMultiple && selectValue.value?.length == 0 && !props.isLoading
                )
                      ? (openBlock(), createElementBlock("p", {
                          key: 3,
                          class: "text-center hover:cursor-pointer",
                          onClick: _cache[1] || (_cache[1] = $event => (selectValue.value = __props.options))
                        }, " Select All "))
                      : createCommentVNode("v-if", true),
                    (!props.isLoading)
                      ? (openBlock(), createElementBlock("span", _hoisted_8, [
                          (openBlock(true), createElementBlock(Fragment, null, renderList(__props.options, (filter, index) => {
                            return (openBlock(), createBlock(unref(ListboxOption), {
                              key: index,
                              value: filter,
                              as: "template"
                            }, {
                              default: withCtx(({ active, selected }) => [
                                createElementVNode("li", {
                                  class: normalizeClass([
                      active
                        ? 'bg-untitled-gray-200 text-untitled-gray-800'
                        : 'text-gray-900',
                      'relative cursor-default select-none py-2 pl-10 pr-4',
                    ])
                                }, [
                                  createElementVNode("span", {
                                    class: normalizeClass([
                        selected ? 'font-medium' : 'font-normal',
                        'block truncate',
                      ])
                                  }, toDisplayString(filter[__props.optionName]), 3 /* TEXT, CLASS */),
                                  selected
                                    ? (openBlock(), createElementBlock("span", _hoisted_9, [
                                        createVNode(unref(CheckIcon), {
                                          class: "h-5 w-5",
                                          "aria-hidden": "true"
                                        })
                                      ]))
                                    : createCommentVNode("v-if", true)
                                ], 2 /* CLASS */)
                              ]),
                              _: 2 /* DYNAMIC */
                            }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["value"]))
                          }), 128 /* KEYED_FRAGMENT */))
                        ]))
                      : createCommentVNode("v-if", true)
                  ]),
                  _: 1 /* STABLE */
                })
              ])
            ]),
            _: 1 /* STABLE */
          })
        ])
      ]),
      _: 1 /* STABLE */
    }, 8 /* PROPS */, ["modelValue", "multiple", "disabled", "name"]),
    createElementVNode("span", _hoisted_10, toDisplayString(unref(errorMessage)), 1 /* TEXT */)
  ]))
}
}

});

script$2.__file = "src/components/VSelect.vue";

const _hoisted_1$1 = { class: "flex flex-col" };
const _hoisted_2 = ["disabled", "name", "value", "placeholder"];
const _hoisted_3 = {
  key: 0,
  class: "mt-2 text-red-500 text-xs italic"
};


const __default__ = {
  name: "VTextField",
};

var script$1 = /*#__PURE__*/Object.assign(__default__, {
  props: {
  modelValue: {
    default: "",
  },
  placeholder: {
    default: "Placeholder",
  },
  rules: {
    default: [],
  },
  name: {
    default: "",
  },
  disabled: {
    default: false,
    type: Boolean,
  },
},
  emits: ["update:modelValue"],
  setup(__props, { emit }) {

const props = __props;





const validateField = (value) => {
  let error = true;

  for (let i = 0; i < props.rules?.length; i++) {
    const rule = props.rules[i];

    error = rule(value);

    if (error != true) {
      break;
    }
  }

  emit("update:modelValue", value);

  return error;
};

const { errorMessage, value, handleChange } = useField(
  props.name,
  validateField,
  {
    validateOnValueUpdate: false,
    initialValue: props?.modelValue,
  }
);

const validationListeners = computed(() => {
  // If the field is valid or have not been validated yet
  // lazy
  if (!errorMessage.value) {
    return {
      blur: handleChange,
      change: handleChange,
      input: (e) => handleChange(e, false),
    };
  }

  // Aggressive
  return {
    blur: handleChange,
    change: handleChange,
    input: handleChange, // only switched this
  };
});

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock("div", _hoisted_1$1, [
    createElementVNode("input", mergeProps({
      disabled: __props.disabled,
      name: __props.name
    }, toHandlers(unref(validationListeners), true), {
      value: unref(value),
      type: "text",
      placeholder: __props.placeholder,
      class: ["block w-full appearance-none rounded-md border border-untitled-gray-300 px-3 py-2 placeholder-untitled-gray-400 shadow-sm focus:border-untitled-gray-500 focus:outline-none focus:ring-untitled-gray-500 sm:text-sm", {
        'border-red-600 placeholder-red-600 shadow-sm focus:border-red-600':
          unref(errorMessage)?.length,
      }]
    }), null, 16 /* FULL_PROPS */, _hoisted_2),
    (unref(errorMessage))
      ? (openBlock(), createElementBlock("span", _hoisted_3, toDisplayString(unref(errorMessage)), 1 /* TEXT */))
      : createCommentVNode("v-if", true)
  ]))
}
}

});

script$1.__file = "src/components/VTextField.vue";

const _hoisted_1 = { class: "mt-2 text-red-500 text-xs italic" };


var script = {
  __name: 'VTimePicker',
  props: {
  modelValue: {
    default: ''
  },
  range:{
    default: false,
    type: Boolean
  },
  disabled:{
    default: false,
    type: Boolean
  },
  enableTimePicker:{
    default: false,
    type: Boolean
  },
  minDate:{
    default: null,
  },
  maxDate:{
    default: null,
  },
  name:{
    default: 'date'
  },
  rules:{
    default: []
  }
},
  emits: ["update:modelValue"],
  setup(__props, { emit }) {

const props = __props;








const validateField = (value) => {
let error = true;

for (let i = 0; i < props.rules?.length; i++) {
  const rule = props.rules[i];

  error = rule(value);

  if (error != true) {
    break;
  }
}

emit("update:modelValue", value);

return error;
};

const { errorMessage, value } = useField(
props.name,
validateField,
{
  validateOnValueUpdate: false,
  initialValue: props?.modelValue !== undefined ? props.modelValue : null,
}
);

return (_ctx, _cache) => {
  return (openBlock(), createElementBlock(Fragment, null, [
    createVNode(unref(Datepicker), {
      modelValue: unref(value),
      "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (isRef(value) ? (value).value = $event : null)),
      class: "text-sm",
      disabled: __props.disabled,
      "time-picker": "",
      "is-24": false
    }, null, 8 /* PROPS */, ["modelValue", "disabled"]),
    createElementVNode("span", _hoisted_1, toDisplayString(unref(errorMessage)), 1 /* TEXT */)
  ], 64 /* STABLE_FRAGMENT */))
}
}

};

script.__file = "src/components/VTimePicker.vue";

export { script$8 as VButton, script$7 as VCombobox, script$6 as VDatePicker, script$5 as VDialog, script$4 as VFileInput, script$3 as VForm, script$2 as VSelect, script$1 as VTextField, script as VTimePicker };
